import { DOMWindow, JSDOM, ConstructorOptions } from "jsdom";
import { Types as TContextRequire } from "context-require";
export declare namespace Types {
    interface Options extends Omit<ConstructorOptions, "beforeParse"> {
        /** The directory from which to resolve requires for this module. */
        dir: string;
        /** The initial html to parse with jsdom. */
        html?: string;
        /** An object containing any browser specific require hooks to be used in this module. */
        extensions?: TContextRequire.Hooks;
        /** A function called with the window, and the module, before parsing html. */
        beforeParse?(window: DOMWindow, context: JSDOMModule): void;
    }
    interface JSDOMModule extends JSDOM {
        require: TContextRequire.RequireFunction;
    }
}
export default createJSDOMContextRequire;
/**
 * Creates a custom Module object which runs all required scripts
 * in a new jsdom instance.
 */
declare function createJSDOMContextRequire(options: Types.Options): Types.JSDOMModule;
